What's the purpose of “true” in bash “if sudo true; then”












11















I've hacked together this script which tests if the user has superuser privileges and if they don't it asks for them. I'm trying to negate the second if statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement? If so, how do I invert the test that line? Here is what I've tried



if sudo false; then  
if sudo true == false; then
if [!(sudo true)]; then









share|improve this question







New contributor




Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.
















  • 1





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    9 hours ago








  • 2





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    9 hours ago






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    9 hours ago






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    9 hours ago






  • 1





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    7 hours ago


















11















I've hacked together this script which tests if the user has superuser privileges and if they don't it asks for them. I'm trying to negate the second if statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement? If so, how do I invert the test that line? Here is what I've tried



if sudo false; then  
if sudo true == false; then
if [!(sudo true)]; then









share|improve this question







New contributor




Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.
















  • 1





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    9 hours ago








  • 2





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    9 hours ago






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    9 hours ago






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    9 hours ago






  • 1





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    7 hours ago
















11












11








11








I've hacked together this script which tests if the user has superuser privileges and if they don't it asks for them. I'm trying to negate the second if statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement? If so, how do I invert the test that line? Here is what I've tried



if sudo false; then  
if sudo true == false; then
if [!(sudo true)]; then









share|improve this question







New contributor




Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.












I've hacked together this script which tests if the user has superuser privileges and if they don't it asks for them. I'm trying to negate the second if statement so that I can remove the following two lines (the echo "password ok" and the else on the following line)



# Root user only
if [[ "$EUID" != 0 ]]; then
sudo -k # make sure to ask for password on next sudo
if sudo true; then
echo "Password ok"
else
echo "Aborting script"
exit 1
fi
fi

echo "do my ops"


Is the purpose of "true" on the fourth line just a null-statement? If so, how do I invert the test that line? Here is what I've tried



if sudo false; then  
if sudo true == false; then
if [!(sudo true)]; then






bash sudo






share|improve this question







New contributor




Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.











share|improve this question







New contributor




Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.









share|improve this question




share|improve this question






New contributor




Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.









asked 10 hours ago









Matt ParkinsMatt Parkins

1645




1645




New contributor




Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.





New contributor





Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.






Matt Parkins is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.








  • 1





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    9 hours ago








  • 2





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    9 hours ago






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    9 hours ago






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    9 hours ago






  • 1





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    7 hours ago
















  • 1





    If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

    – Matt Parkins
    9 hours ago








  • 2





    Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

    – Jeff Schaller
    9 hours ago






  • 1





    see stackoverflow.com/q/10552711/537980

    – ctrl-alt-delor
    9 hours ago






  • 1





    @ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

    – Matt Parkins
    9 hours ago






  • 1





    In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

    – Toby Speight
    7 hours ago










1




1





If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

– Matt Parkins
9 hours ago







If you're going to downvote the question, please could you explain what I can do to improve the question? Is this not the right overflow site?

– Matt Parkins
9 hours ago






2




2





Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

– Jeff Schaller
9 hours ago





Not sure where the downvotes are coming from; are you trying to negate the statement or nullify the statement? You say you want to get rid of both the true/echo and the "else", so what's your final objective?

– Jeff Schaller
9 hours ago




1




1





see stackoverflow.com/q/10552711/537980

– ctrl-alt-delor
9 hours ago





see stackoverflow.com/q/10552711/537980

– ctrl-alt-delor
9 hours ago




1




1





@ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

– Matt Parkins
9 hours ago





@ctrl-alt-delor following that link it seems all I need do is put an exclamation mark in front of the sudo and then I can remove both the echo and the else, and now i've tested it, that works, thanks.

– Matt Parkins
9 hours ago




1




1





In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

– Toby Speight
7 hours ago







In passing, you probably ought to redirect the error message to the error stream: echo "Aborting script" >&2

– Toby Speight
7 hours ago












2 Answers
2






active

oldest

votes


















19














true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
Likewise, false is a program that exits with an unsuccessful exit code.



You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



true
echo $? # 0
false
echo $? #1


if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



Therefore:



if sudo false; then is running the program false as sudo. The return will always be false.



if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



if [!(sudo true)] is invalid syntax.



What you are probably looking for is



if ! sudo true;





share|improve this answer








New contributor




JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
Check out our Code of Conduct.
















  • 3





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    5 hours ago








  • 5





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    5 hours ago





















2














I feel like the accepted answer didn't actually answer your question?



The purpose of doing this is to check that you can actually sudo.



How this check is performed is via the true program as explained in the accepted answer.






share|improve this answer























    Your Answer








    StackExchange.ready(function() {
    var channelOptions = {
    tags: "".split(" "),
    id: "106"
    };
    initTagRenderer("".split(" "), "".split(" "), channelOptions);

    StackExchange.using("externalEditor", function() {
    // Have to fire editor after snippets, if snippets enabled
    if (StackExchange.settings.snippets.snippetsEnabled) {
    StackExchange.using("snippets", function() {
    createEditor();
    });
    }
    else {
    createEditor();
    }
    });

    function createEditor() {
    StackExchange.prepareEditor({
    heartbeatType: 'answer',
    autoActivateHeartbeat: false,
    convertImagesToLinks: false,
    noModals: true,
    showLowRepImageUploadWarning: true,
    reputationToPostImages: null,
    bindNavPrevention: true,
    postfix: "",
    imageUploader: {
    brandingHtml: "Powered by u003ca class="icon-imgur-white" href="https://imgur.com/"u003eu003c/au003e",
    contentPolicyHtml: "User contributions licensed under u003ca href="https://creativecommons.org/licenses/by-sa/3.0/"u003ecc by-sa 3.0 with attribution requiredu003c/au003e u003ca href="https://stackoverflow.com/legal/content-policy"u003e(content policy)u003c/au003e",
    allowUrls: true
    },
    onDemand: true,
    discardSelector: ".discard-answer"
    ,immediatelyShowMarkdownHelp:true
    });


    }
    });






    Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.










    draft saved

    draft discarded


















    StackExchange.ready(
    function () {
    StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f508756%2fwhats-the-purpose-of-true-in-bash-if-sudo-true-then%23new-answer', 'question_page');
    }
    );

    Post as a guest















    Required, but never shown

























    2 Answers
    2






    active

    oldest

    votes








    2 Answers
    2






    active

    oldest

    votes









    active

    oldest

    votes






    active

    oldest

    votes









    19














    true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
    Likewise, false is a program that exits with an unsuccessful exit code.



    You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



    true
    echo $? # 0
    false
    echo $? #1


    if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



    Therefore:



    if sudo false; then is running the program false as sudo. The return will always be false.



    if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



    if [!(sudo true)] is invalid syntax.



    What you are probably looking for is



    if ! sudo true;





    share|improve this answer








    New contributor




    JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.
















    • 3





      As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

      – IMSoP
      5 hours ago








    • 5





      PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

      – IMSoP
      5 hours ago


















    19














    true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
    Likewise, false is a program that exits with an unsuccessful exit code.



    You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



    true
    echo $? # 0
    false
    echo $? #1


    if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



    Therefore:



    if sudo false; then is running the program false as sudo. The return will always be false.



    if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



    if [!(sudo true)] is invalid syntax.



    What you are probably looking for is



    if ! sudo true;





    share|improve this answer








    New contributor




    JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.
















    • 3





      As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

      – IMSoP
      5 hours ago








    • 5





      PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

      – IMSoP
      5 hours ago
















    19












    19








    19







    true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
    Likewise, false is a program that exits with an unsuccessful exit code.



    You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



    true
    echo $? # 0
    false
    echo $? #1


    if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



    Therefore:



    if sudo false; then is running the program false as sudo. The return will always be false.



    if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



    if [!(sudo true)] is invalid syntax.



    What you are probably looking for is



    if ! sudo true;





    share|improve this answer








    New contributor




    JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.










    true in bash isn't a keyword, it's a program that instantly exits with a successful exit code.
    Likewise, false is a program that exits with an unsuccessful exit code.



    You can try this out by running both programs from your terminal, and then reading the $? variable, which contains the exit code of the last program;



    true
    echo $? # 0
    false
    echo $? #1


    if sudo true isn't equivalent to if sudo == true. if sudo true is running the true program using sudo, and checking the exit code.



    Therefore:



    if sudo false; then is running the program false as sudo. The return will always be false.



    if sudo true == false will run the program true with the arguments == and false using sudo. This obviously isn't want you intended.



    if [!(sudo true)] is invalid syntax.



    What you are probably looking for is



    if ! sudo true;






    share|improve this answer








    New contributor




    JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.









    share|improve this answer



    share|improve this answer






    New contributor




    JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.









    answered 9 hours ago









    JShorthouseJShorthouse

    32316




    32316




    New contributor




    JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.





    New contributor





    JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.






    JShorthouse is a new contributor to this site. Take care in asking for clarification, commenting, and answering.
    Check out our Code of Conduct.








    • 3





      As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

      – IMSoP
      5 hours ago








    • 5





      PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

      – IMSoP
      5 hours ago
















    • 3





      As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

      – IMSoP
      5 hours ago








    • 5





      PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

      – IMSoP
      5 hours ago










    3




    3





    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    5 hours ago







    As a slightly pedantic correction to the first sentence: in bash, true and false are "builtins", commands interpreted directly by the shell; in Unix-like systems in general, they also exist as standalone programs on the file system. The difference doesn't matter that much here, but as far as I know, sudo true will be running the standalone program, not the bash builtin.

    – IMSoP
    5 hours ago






    5




    5





    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    5 hours ago







    PS: my favourite summaries of true and false are the titles on their man pages: true - do nothing, successfully and false - do nothing, unsuccessfully

    – IMSoP
    5 hours ago















    2














    I feel like the accepted answer didn't actually answer your question?



    The purpose of doing this is to check that you can actually sudo.



    How this check is performed is via the true program as explained in the accepted answer.






    share|improve this answer




























      2














      I feel like the accepted answer didn't actually answer your question?



      The purpose of doing this is to check that you can actually sudo.



      How this check is performed is via the true program as explained in the accepted answer.






      share|improve this answer


























        2












        2








        2







        I feel like the accepted answer didn't actually answer your question?



        The purpose of doing this is to check that you can actually sudo.



        How this check is performed is via the true program as explained in the accepted answer.






        share|improve this answer













        I feel like the accepted answer didn't actually answer your question?



        The purpose of doing this is to check that you can actually sudo.



        How this check is performed is via the true program as explained in the accepted answer.







        share|improve this answer












        share|improve this answer



        share|improve this answer










        answered 2 hours ago









        MehrdadMehrdad

        1,22641533




        1,22641533






















            Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.










            draft saved

            draft discarded


















            Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.













            Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.












            Matt Parkins is a new contributor. Be nice, and check out our Code of Conduct.
















            Thanks for contributing an answer to Unix & Linux Stack Exchange!


            • Please be sure to answer the question. Provide details and share your research!

            But avoid



            • Asking for help, clarification, or responding to other answers.

            • Making statements based on opinion; back them up with references or personal experience.


            To learn more, see our tips on writing great answers.




            draft saved


            draft discarded














            StackExchange.ready(
            function () {
            StackExchange.openid.initPostLogin('.new-post-login', 'https%3a%2f%2funix.stackexchange.com%2fquestions%2f508756%2fwhats-the-purpose-of-true-in-bash-if-sudo-true-then%23new-answer', 'question_page');
            }
            );

            Post as a guest















            Required, but never shown





















































            Required, but never shown














            Required, but never shown












            Required, but never shown







            Required, but never shown

































            Required, but never shown














            Required, but never shown












            Required, but never shown







            Required, but never shown







            Popular posts from this blog

            How to make a Squid Proxy server?

            第一次世界大戦

            Touch on Surface Book